///+------------------------------------------------------------------+
//|                                                     Controls.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include "../include/canvas/Canvas.mqh"
#include "../include/K2M_Astro_dialog.mqh"
#property indicator_chart_window

//+------------------------------------------------------------------+
//| Global Variables                                                 |
//+------------------------------------------------------------------+
CControlsDialog ExtDialog;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
bool ok;
string nome_canvas;
color color_mercury;
uint xrgb_mercury;
int ChartWidth,ChartHeight;
CCanvas can;
ENUM_COLOR_FORMAT m_format=COLOR_FORMAT_ARGB_RAW;
int OnInit()
  {
      color_mercury = clrDarkOrange;
      xrgb_mercury=ColorToARGB(color_mercury);
      ChartWidth=ChartWidthInPixels();
      ChartHeight=ChartHeightInPixelsGet();
      int can_width=ChartWidth;int can_height=ChartHeight;
      int  can_x1=0;            int  can_y1=0;
      int  can_x2=can_width;  int   can_y2=0;
      int  can_x3=can_width*2; int   can_y3=0;  
  
      nome_canvas="K2M_MySpace"+Symbol()+IntegerToString(Period())+TimeHour(TimeCurrent())+TimeMinute(TimeCurrent())+TimeSeconds(TimeCurrent())+MathRand();
      ok=can.Create(nome_canvas,can_width,can_height,m_format);
      if(ok==true)can.CreateBitmapLabel(0,0,nome_canvas,can_x1,can_y1,can_width,can_height,m_format);
  
//--- create application dialog
   if(!ExtDialog.Create(0,"K2M Astro Dialog",0,20,20,360,430))
     return(-1);
//--- run application
   ExtDialog.Run();

   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy dialog
   ExtDialog.Destroy(reason);
   can.Destroy();
   ObjectDelete(nome_canvas);
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//--- return value of prev_calculated for next call
           can.Line(0,0,500,500,xrgb_mercury);
           can.Update();

   return(rates_total);
  }  
//+------------------------------------------------------------------+
//| Expert chart event function                                      |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         // event ID  
                  const long& lparam,   // event parameter of the long type
                  const double& dparam, // event parameter of the double type
                  const string& sparam) // event parameter of the string type
  {
   //if(id==CHARTEVENT_MOUSE_MOVE ){
   //   int      x     =(int)lparam;
   //   int      y     =(int)dparam;  
   //   datetime dt;
   //   double price;
   //   int      window=0;
   //   ChartXYToTimePrice(0,x,y,window,dt,price);
   //    string  a="Date: "+ TimeToStr(dt)+" Price : "+DoubleToStr(price,Digits);
   //     ExtDialog.m_label_box.Text(a);
   //}
   int check0=  ExtDialog.m_check_group.Check(0);
   int check1=  ExtDialog.m_check_group.Check(1);
   int check2=  ExtDialog.m_check_group.Check(2);
   ExtDialog.m_label_box.Text(IntegerToString(ExtDialog.m_check_group.Check(0))+" "+IntegerToString(ExtDialog.m_check_group.Check(1)));
   ExtDialog.ChartEvent(id,lparam,dparam,sparam);

      
      
  }
//+-------------------------------------------------------
//+------------------------------------------------------------------+
//| Check if messages concerning move events and mouse clicks        |
//| are sent to all mql4 applications on the chart.                  |
//+------------------------------------------------------------------+
bool ChartEventMouseMoveGet(bool &result,const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long value;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_EVENT_MOUSE_MOVE,0,value))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//--- store the value of the chart property in memory
   result=value;
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------------------+
//| The function enables/disables the mode of sending messages concerning move   |
//| events and mouse clicks to mql4 applications on the                          |
//| chart.                                                                       |
//+------------------------------------------------------------------------------+
bool ChartEventMouseMoveSet(const bool value,const long chart_ID=0)
  {
//--- reset the error value
   ResetLastError();
//--- set property value
   if(!ChartSetInteger(chart_ID,CHART_EVENT_MOUSE_MOVE,0,value))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }    
  int ChartWidthInPixels(const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
//| Chart property height                                            |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
